﻿using System;
using System.IO;
using Newtonsoft.Json.Linq;
namespace flightBooking.Class
{

	public class Flight
	{

		private String id;
		private String from;
		private String to;
		private String departureTime;
		private String arriveTime;
		private Int32 numberOfSeats;
		private Int32 availableSeats;
		private MessageHandler messageHandler;
		public String Id { get => id; set => id = value; }
		public String From { get => from; set => from = value; }
		public String To { get => to; set => to = value; }
		public String DepartureTime { get => departureTime; set => departureTime = value; }
		public String ArriveTime { get => arriveTime; set => arriveTime = value; }
		public Int32 NumberOfSeats { get => numberOfSeats; set => numberOfSeats = value; }
		public Int32 AvailableSeats { get => availableSeats; set => availableSeats = value; }



		public Flight()
		{
			JObject properties = JObject.Parse(File.ReadAllText(@"../../Resources/properties.json"));
			this.messageHandler = new MessageHandler(properties.GetValue("appKey").ToString(), properties.GetValue("appSecret").ToString(), properties.GetValue("defaultOrigin").ToString());

		}

		public Flight(String id, String from, String to, String departureTime, String arriveTime, Int32 numberOfSeats = 10)
		{
			this.id = id;
			this.from = from;
			this.to = to;
			this.departureTime = departureTime;
			this.arriveTime = arriveTime;
			this.numberOfSeats = numberOfSeats;
			this.availableSeats = numberOfSeats;
			JObject properties = JObject.Parse(File.ReadAllText(@"../../Resources/properties.json"));
			this.messageHandler = new MessageHandler(properties.GetValue("appKey").ToString(), properties.GetValue("appSecret").ToString(), properties.GetValue("defaultOrigin").ToString());
		}

		public String getAvailableSeatsAndAssign(Int32 numberOfSeatsToBook)
		{
			if (numberOfSeatsToBook > this.availableSeats) {
				return "Seats amount to book is higher than the seats avalaible for flight " + this.id;
			}
			this.availableSeats -= numberOfSeatsToBook;
			return this.id + "-" + this.availableSeats;

		}

		public void bookFlight(Customer customer)
		{
			String message = "Hi " + customer.FirstName + " your flight has been booked with seat number " + getAvailableSeatsAndAssign(1) +
											 ", from: " + this.from + ", to: " + this.to + ", departuring at " + this.departureTime;
			messageHandler.sendMessage(message, customer.PhoneNumber);
		}

		public void checkIfFlightIsDelayed(String newDepartureTime, Customer customer)
		{
			if (this.DepartureTime != newDepartureTime) {
				String message = "Flight " + this.id + " from: " + this.from + " to: " + this.to + " is delayed, the new departure time will be at " + newDepartureTime;
				messageHandler.sendMessage(message, customer.PhoneNumber);
			}
		}
	}
}
